package com.jb.gosms.fm.core.xmpp.service;

import com.jb.gosms.fm.core.bean.XMPPEntry;
import com.jb.gosms.fm.core.bean.XMPPEntryState;
import com.jb.gosms.fm.core.bean.XMPPRoom;
import com.jb.gosms.fm.core.bean.XMPPRoomMsg;
import com.jb.gosms.fm.core.bean.XMPPRoomsResult;


interface IFreeMsgXMPPRemote {
	void setIsTestModeOn(boolean isTestModeOn);

	boolean getAccount(out XMPPEntry result);

	void login(String username, String password);

	void loginByToken(String token);

	void disconnect();

	boolean isOnline();
	
	boolean isOnlines(in List<String> jids,out List<XMPPEntryState> result);
	
	boolean getJid(String phone,out XMPPEntryState result);
	
	boolean getJids(in List<String> phones,out List<XMPPEntryState> result);
	
	boolean getFriends(out List<XMPPEntry> result);
	
	void sendMessage(String jid, String packetId, String phone, String msg);
	
	void sendAnonymousMsg(String jid, String packetId, String from, String to, String msgContent, int msgCount);
	
	boolean ping(String jid);
	
	boolean getRoom(String roomId,out XMPPRoom result);
	
	boolean getRooms(String curVersion, out XMPPRoomsResult result);
	
	String createRoom(String roomName, String members);
	
	boolean renameRoom(String roomId,String roomName);
	
	boolean exitRoom(String roomId);
	
	boolean invite(String roomId, String members);
	
	boolean kickout(String roomId, String members);
	
	boolean setNoticeSwitch(String roomId,boolean isNotice);
	
	boolean getRoomMessages(in List<String> rooms,String lastRoomMsgTime,out List<XMPPRoomMsg> result);
	
	void sendGroupMessage( String jid,String packetId, String msg);
	
	long getLastRoomMsgTime();
}